<html lang="en">
<head>
    <meta charset="UTF-8">
    <meta http-equiv="X-UA-Compatible" content="IE=edge">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <title>irc</title>
    <script type="text/javascript" src="https://code.jquery.com/jquery-3.6.0.min.js"></script>
    <script type="text/javascript" src="/jquery.slimscroll.min.js"></script>
    <style>
        b {
            font-weight: bold;
        }

        i {
            color: #5a8ad3;
            font-weight: bolder;
        }

        s {
            text-decoration: none;
            color: rgb(226, 75, 75);
        }

        pre { margin-bottom: 0; margin-top: 0; }

        div {
            height: 90vh;
            margin-top: 5px;
            margin-bottom: 5px;
        }

        input[type="text"] {
            border: 0;
            border-bottom: 2px solid #e9c3aa;
        }

        pre, div#msgs, input[type="text"] {
            font-family: 'Courier New', Courier, monospace;
            font-size: 1em;
            width: 100%;
            color: #e9c3aa;
            background-color: #271719;
        }

        body {
            padding-left: 15px;
            padding-right: 15px;
            background-color: #181011;
        }
    </style>
</head>
<body>
    <div id="msgs"></div>
    <input type="text" name="input" id="input" onkeydown="keydown(event)"/>
    <script>
        $(function(){
            $('#msgs').slimScroll({
                color: '#e9c3aa',
                height: '90vh'
            });
        });
        const emojis = {
            'O:)': '😇',
            '>:)': '😈',
            '>:(': '👿',
            ':\'(': '😢',
            '<3': '💕',
            ':)': '🙂',
            ':D': '😀',
            'xD': '😆',
            ':/': '😕',
            ':|': '😐',
            ':(': '🙁',
            ':P': '😋',
            ':O': '😮',
            ':S': '😵',
            'B)': '😎',
        };

        const beep = new Audio("/beep.aac");
        const name = prompt("nick: ");

        const msgs_dom = document.getElementById("msgs");
        const input_dom = document.getElementById("input");

        function keydown(event) {
            if (event.key === "Enter") send();
        }

        function send() {
            const url = "/send?name=" + encodeURIComponent(name) + "&text=" + encodeURIComponent(input_dom.value);
            fetch(url, {
                method: "POST"
            }).catch(err => { console.error(err); });
            input_dom.value = "";
        }

        function recv() {
            const url = "/recv?name=" + encodeURIComponent(name);
            fetch(url, {
                method: "POST",
                headers: {
                    "Keep-Alive": "timeout=50"
                }
            })
            .then(res => res.json())
            .then(json => { 
                recv();
                beep.play();
                msgs_dom.innerHTML += print(json);
                msgs_dom.scrollTo(0,msgs_dom.scrollHeight);
            })
            .catch(err => {
                recv();
            })
        }

        function print(msg) {
            return "<pre><b>[" + decodeURI(msg.date) + "]&lt;" + decodeURI(msg.name) + "&gt;</b> " + emoji(decodeURI(msg.text)) + "<pre>";
        }

        function emoji(text) {
            let altered = text;
            for (const symbol in emojis) {
                altered = altered.replaceAll(symbol, emojis[symbol]);
            }
            return altered;
        }

        recv();
    </script>
</body>
</html>